import { DismissBannerRequestDto, OwnerSetupRequestDto } from '@n8n/api-types';
import { Response } from 'express';
import { Logger } from 'n8n-core';
import { AuthService } from '../auth/auth.service';
import { SettingsRepository } from '../databases/repositories/settings.repository';
import { UserRepository } from '../databases/repositories/user.repository';
import { EventService } from '../events/event.service';
import { PostHogClient } from '../posthog';
import { AuthenticatedRequest } from '../requests';
import { PasswordUtility } from '../services/password.utility';
import { UserService } from '../services/user.service';
export declare class OwnerController {
    private readonly logger;
    private readonly eventService;
    private readonly settingsRepository;
    private readonly authService;
    private readonly userService;
    private readonly passwordUtility;
    private readonly postHog;
    private readonly userRepository;
    constructor(logger: Logger, eventService: EventService, settingsRepository: SettingsRepository, authService: AuthService, userService: UserService, passwordUtility: PasswordUtility, postHog: PostHogClient, userRepository: UserRepository);
    setupOwner(req: AuthenticatedRequest, res: Response, payload: OwnerSetupRequestDto): Promise<import("../interfaces").PublicUser>;
    dismissBanner(_req: AuthenticatedRequest, _res: Response, payload: DismissBannerRequestDto): Promise<{
        success: boolean;
    } | undefined>;
}
