import { WithStringId } from '../../databases/entities/abstract-entity';
import type { ExecutionEntity } from '../../databases/entities/execution-entity';
import { TestRun } from '../../databases/entities/test-run.ee';
export type TestCaseRunMetrics = Record<string, number | boolean>;
export declare class TestCaseExecution extends WithStringId {
    testRun: TestRun;
    pastExecution: ExecutionEntity | null;
    pastExecutionId: string | null;
    execution: ExecutionEntity | null;
    executionId: string | null;
    evaluationExecution: ExecutionEntity | null;
    evaluationExecutionId: string | null;
    status: 'new' | 'running' | 'evaluation_running' | 'success' | 'error' | 'cancelled';
    runAt: Date | null;
    completedAt: Date | null;
    errorCode: string | null;
    errorDetails: Record<string, unknown>;
    metrics: TestCaseRunMetrics;
}
