import { WithTimestampsAndStringId } from '../../databases/entities/abstract-entity';
import { TestDefinition } from '../../databases/entities/test-definition.ee';
type TestRunStatus = 'new' | 'running' | 'completed' | 'error' | 'cancelled';
export type AggregatedTestRunMetrics = Record<string, number | boolean>;
export declare class TestRun extends WithTimestampsAndStringId {
    testDefinition: TestDefinition;
    testDefinitionId: string;
    status: TestRunStatus;
    runAt: Date | null;
    completedAt: Date | null;
    metrics: AggregatedTestRunMetrics;
    totalCases: number;
    passedCases: number;
    failedCases: number;
}
export {};
