import { DataSource, Repository } from '@n8n/typeorm';
import { ErrorReporter } from 'n8n-core';
import { Settings } from '../entities/settings';
export declare class SettingsRepository extends Repository<Settings> {
    private readonly errorReporter;
    constructor(dataSource: DataSource, errorReporter: ErrorReporter);
    getEncryptedSecretsProviderSettings(): Promise<string | null>;
    findByKey(key: string): Promise<Settings | null>;
    saveEncryptedSecretsProviderSettings(data: string): Promise<void>;
    dismissBanner({ bannerName }: {
        bannerName: string;
    }): Promise<{
        success: boolean;
    }>;
}
