import type { EntityManager } from '@n8n/typeorm';
import { DataSource, Repository } from '@n8n/typeorm';
import { TestCaseExecution } from '../../databases/entities/test-case-execution.ee';
export declare class TestCaseExecutionRepository extends Repository<TestCaseExecution> {
    constructor(dataSource: DataSource);
    createBatch(testRunId: string, pastExecutionIds: string[]): Promise<TestCaseExecution[]>;
    markAsRunning(testRunId: string, pastExecutionId: string, executionId: string): Promise<import("@n8n/typeorm").UpdateResult>;
    markAsEvaluationRunning(testRunId: string, pastExecutionId: string, evaluationExecutionId: string): Promise<import("@n8n/typeorm").UpdateResult>;
    markAsCompleted(testRunId: string, pastExecutionId: string, metrics: Record<string, number>, trx?: EntityManager): Promise<import("@n8n/typeorm").UpdateResult>;
    markAllPendingAsCancelled(testRunId: string, trx?: EntityManager): Promise<import("@n8n/typeorm").UpdateResult>;
    markAsFailed(testRunId: string, pastExecutionId: string, trx?: EntityManager): Promise<import("@n8n/typeorm").UpdateResult>;
}
