import express from 'express';
import { InstanceSettings } from 'n8n-core';
import { TestCaseExecutionRepository } from '../databases/repositories/test-case-execution.repository.ee';
import { TestRunRepository } from '../databases/repositories/test-run.repository.ee';
import { TestRunsRequest } from '../evaluation.ee/test-definitions.types.ee';
import { TestRunnerService } from '../evaluation.ee/test-runner/test-runner.service.ee';
import { TestDefinitionService } from './test-definition.service.ee';
export declare class TestRunsController {
    private readonly testDefinitionService;
    private readonly testRunRepository;
    private readonly testCaseExecutionRepository;
    private readonly testRunnerService;
    private readonly instanceSettings;
    constructor(testDefinitionService: TestDefinitionService, testRunRepository: TestRunRepository, testCaseExecutionRepository: TestCaseExecutionRepository, testRunnerService: TestRunnerService, instanceSettings: InstanceSettings);
    private getTestDefinition;
    private getTestRun;
    getMany(req: TestRunsRequest.GetMany): Promise<import("../databases/entities/test-run.ee").TestRun[]>;
    getOne(req: TestRunsRequest.GetOne): Promise<import("../databases/entities/test-run.ee").TestRun>;
    getTestCases(req: TestRunsRequest.GetCases): Promise<import("../databases/entities/test-case-execution.ee").TestCaseExecution[]>;
    delete(req: TestRunsRequest.Delete): Promise<{
        success: boolean;
    }>;
    cancel(req: TestRunsRequest.Cancel, res: express.Response): Promise<void>;
}
