"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NoUrl = NoUrl;
const class_validator_1 = require("class-validator");
const URL_REGEX = /^(https?:\/\/|www\.)|(\.[\p{L}\d-]+)/iu;
let NoUrlConstraint = class NoUrlConstraint {
    validate(value) {
        return !URL_REGEX.test(value);
    }
    defaultMessage() {
        return 'Potentially malicious string';
    }
};
NoUrlConstraint = __decorate([
    (0, class_validator_1.ValidatorConstraint)({ name: 'NoUrl', async: false })
], NoUrlConstraint);
function NoUrl(options) {
    return function (object, propertyName) {
        (0, class_validator_1.registerDecorator)({
            name: 'NoUrl',
            target: object.constructor,
            propertyName,
            options,
            validator: NoUrlConstraint,
        });
    };
}
//# sourceMappingURL=no-url.validator.js.map