import { InstanceSettings } from 'n8n-core';
import type { IWebhookData } from 'n8n-workflow';
import type { IWorkflowDb } from '../interfaces';
import { CacheService } from '../services/cache/cache.service';
export type TestWebhookRegistration = {
    pushRef?: string;
    workflowEntity: IWorkflowDb;
    destinationNode?: string;
    webhook: IWebhookData;
};
export declare class TestWebhookRegistrationsService {
    private readonly cacheService;
    private readonly instanceSettings;
    constructor(cacheService: CacheService, instanceSettings: InstanceSettings);
    private readonly cacheKey;
    register(registration: TestWebhookRegistration): Promise<void>;
    deregister(arg: IWebhookData | string): Promise<void>;
    get(key: string): Promise<TestWebhookRegistration | undefined>;
    getAllKeys(): Promise<string[]>;
    getAllRegistrations(): Promise<TestWebhookRegistration[]>;
    deregisterAll(): Promise<void>;
    toKey(webhook: Pick<IWebhookData, 'webhookId' | 'httpMethod' | 'path'>): string;
}
